<?php
/*
Plugin Name: flexible Accordion
Plugin URI: http://katzplus.com/
Description: なんとなくフレキシブルなAccordionを目指しています。現状は単にslideToggleできるだけです。
Author: katz
Version: 0.1
Author URI: http://katzplus.com/
*/

// 実際のショートコード用のソースここから
$katz_fa_global_num = 10000;

// 「flex-acc」全体を囲むショートコード
add_shortcode('flex-acc', 'faAdd');
function faAdd($param, $content = null) {
  // shortcodeからの値を取得 or デフォルト値を採用
  extract(
    shortcode_atts(
      array( 'opentab' => 'open'
            ,'relate' => 'relate'
      )
      , $param
    )
  );
  // タグのデフォルト値を決めておく
  $katz_fa_start = '<div id="katz_fa_'.rand(100, 999).'">';
  $katz_fa_end = '</div>';

  // 全てデフォルトのままだったらデフォルト値を採用
  if (($opentab.$relate) == "openrelate") {
    $opentab= get_option('katz_fa_default_tab');
    $relate = get_option('katz_fa_default_rel');
  // 「openrelate」でなかったら指定値もしくは規定値を採用
  } else {
    $opentab = (is_null($opentab)) ? 1 : intval($opentab);
    $relate = (is_null($relate)) ? "off" : $relate;
  }
  $ret = $katz_fa_start.do_shortcode($content).$katz_fa_end;
  return $ret;
}

// 「fa_title」タイトル部分を囲むショートコード
add_shortcode('fa_title', 'fatAdd');
function fatAdd($title_param, $content = null) {
  global $katz_fa_global_num;
  // shortcodeからの値を取得 or デフォルト値を採用
  extract(
    shortcode_atts(
      array( 'name' => $katz_fa_global_num
            ,'status' => close
      )
      , $title_param
    )
  );
  // タグのデフォルト値を決めておく
  $katz_fat_start = '<span class="katz_fa_title" id="katz_fa_title_'.$name.'" style="cursor:pointer;">';
  $katz_fat_end = '</span>';

  $ret = $katz_fat_start.do_shortcode($content).$katz_fat_end;
  return $ret;
}

// 「fa_content」本文を囲むショートコード
add_shortcode('fa_content', 'facAdd');
function facAdd($content_param, $content = null) {
  global $katz_fa_global_num;
  // shortcodeからの値を取得 or デフォルト値を採用
  extract(
    shortcode_atts(
      array( 'name' => $katz_fa_global_num
            ,'status' => open
      )
      , $content_param
    )
  );
  // タグのデフォルト値を決めておく
  $katz_fac_status = ($status == "close") ? "none" : "block";
  $katz_fac_start = '<div class="katz_fa_content" id="katz_fa_content_'.$name.'" style="display:'.$katz_fac_status.'">';
  $katz_fac_end = '</div>
  <script>
    jQuery("#katz_fa_title_'.$name.'").click(function () {
      jQuery("#katz_fa_content_'.$name.'").slideToggle("fast");
    });
  </script>
  ';

  if ($name == "fa_content_".$katz_fa_global_num) { $katz_fa_global_num++; }
  $ret = $katz_fac_start.do_shortcode($content).$katz_fac_end;
  return $ret;
}

// 「fa_switch」全てを開閉するショートコード
add_shortcode('fa_switch', 'faopencloseAdd');
function faopencloseAdd($param) {

  // shortcodeからの値を取得 or デフォルト値を採用
  extract(
    shortcode_atts(
      array( 'name' => $katz_fa_global_num
            ,'status' => open
      )
      , $param
    )
  );
  // タグのデフォルト値を決めておく
  $katz_faopenclose = '<div align="right"><span id="katz_fa_openAll" style="display: block;">ALL OPEN</span><span id="katz_fa_closeAll" style="display: none;">ALL CLOSE</span></div>
  <script>
    jQuery("#katz_fa_openAll").click(function () {
      jQuery(\'[class^="katz_fa_content"]\').each(function() {
        jQuery(this).slideDown("fast");
      });
      jQuery(this).css("display", "none");
      jQuery("#katz_fa_closeAll").css("display", "block");
    });
    jQuery("#katz_fa_closeAll").click(function () {
      jQuery(\'[class^="katz_fa_content"]\').each(function() {
        jQuery(this).slideUp("fast");
      });
      jQuery(this).css("display", "none");
      jQuery("#katz_fa_openAll").css("display", "block");
    });
  </script>
  ';

  $ret = $katz_faopenclose;
  return $ret;
}

// 実際のショートコード用のソースここまで

// スタイルシート読み込みのソースここから
add_action('wp_head', 'faCss');
function faCss() {
  echo '<style type="text/css">'."
<!--
.katz_fa_title {
  font-weight: bold; color: #6661F8;
}
.katz_fa_content {
  border: 1px solid #D6D6D6;
  background-color: #F9F9F9;
  border-radius: 6px 6px 6px 6px;
  margin: 0 0 10px;
  padding: 10px;
}
#katz_fa_openAll, #katz_fa_closeAll {
  cursor: pointer;
  text-align: center;
  border: 1px solid #B9B9B9;
  background-color: #FFFFFF;
  padding: 2px;
  width: 80px;
}
 -->
</style>
";
}
// スタイルシート読み込みのソースここまで

